SystemOrganization addCategory: #'Sudoku-Tenn2'!

CustomHelp subclass: #SudokuHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'Sudoku-Tenn2'!

!SudokuHelp class methodsFor: 'pages' stamp: 'DWT 5/4/2013 16:52:29.616'!
about
	^HelpTopic
		title: 'About Sudoku'
		contents: 
		
'About Sudoku:

This puzzle program is the first program these two authors have written in the Squeak computing environment. Anyone who has bothered to program using Squeak will understand that authors of this program have learned a lot about Squeak by writing it.

Sudoku itself is a number grouping puzzle. The puzzle starts off with numbers in a grid pattern. This grid pattern is subdivided into nine grids of nine cells each for a total of 81 cells in the whole puzzle. The object of the game is to try to fill the remaining empty cells with the numbers from one to nine. You must make sure that no number is repeated in any row, column, or in any of the subdivided nine by nine grids.
'! !

!SudokuHelp class methodsFor: 'accessing' stamp: 'DWT 4/11/2013 15:53:41.706'!
bookName
	^'Sudoku help'! !

!SudokuHelp class methodsFor: 'pages' stamp: 'DWT 5/4/2013 17:27:53.782'!
developers
	^HelpTopic
		title: 'Developers'
		contents: 
		
'Developers:

This is a father son effort. The son wanted to learn a new programming language after learning Scratch, and decided to work on learning some of the underpinnings of the Scratch language which at the time was Squeak. The father of the team has done a lot of programming in other languages previously, but soon discovered how unique Squeak is. It is a joy and a pain. When you get something working it is quite clean, but the learning curve is steep, and at times appears to be random trial and error since documentation of the language is basically lore and is rather sketchy at best, at least on all the on-ine sources that we have discovered.

'! !

!SudokuHelp class methodsFor: 'pages' stamp: 'DWT 5/4/2013 16:59:54.668'!
development
	^HelpTopic
		title: 'Development'
		contents: 
		
'Development:

We need to develop a testing engine to test out the players possible solutions to a given Sudoku puzzle. We also hope to develop a hinting engine to provide hints while trying to solve a puzzle. Finally we hope to be able to create a Sudoku puzzle generator. 

'! !

!SudokuHelp class methodsFor: 'pages' stamp: 'DWT 5/4/2013 17:24:43.448'!
howToPlay
	^HelpTopic
		title: 'How to play'
		contents: 
		
'How to play:

First, you need to have a sudoku puzzle to solve. If you need a source, you can get a puzzle from many daily newspapers. Enter the puzzle starting numbers into their corresponding cells on the Sudoku grid. As you enter them, it is a good idea to lock them. You can do this by hovering over the cell you wish to lock and typing the L key. If you wish to unlock a cell, simply type the U key. After entering in all the starting numbers it is a good idea to save the puzzle. You can do that by clicking on the Save menu item on the right of the puzzle grid. You can give credit to the author by considering the name that you give the puzzle file.

Another way to get a sudoku puzzle to solve is to open an already saved one. For this use click on the Open button on the right of the game grid.

Place the mouse in the cell you wish to put a number in. If the cell is not locked, you can type any number from one to nine in it. If there is a red number in the cell, it is locked and you may not change that cell number. If you want to return any unlocked cell to an empty number, simply type the number zero in the cell. 

At any point in the game, you can save your work and return to it another time by using the Save menu item.

The New menu item is to start a new puzzle with a cleared grid.

Hint does not work yet.

Create also does not yet work.

ENJOY.
'! !

!SudokuHelp class methodsFor: 'pages' stamp: 'DWT 5/4/2013 16:54:33.396'!
introduction
	^HelpTopic
		title: 'Introduction'
		contents: 
		
'Introduction:

This Sudoku program lets you create, save, and load your own puzzles, or previously published Sudoku  puzzles.

'! !

!SudokuHelp class methodsFor: 'accessing' stamp: 'DWT 5/4/2013 17:28:07.766'!
pages
	^#( introduction howToPlay about development developers)! !

BorderedMorph subclass: #Sudoku
	instanceVariableNames: 'sudokuGame sudokuMenu blocks menuTitles menuItems menuBlocks'
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'Sudoku-Tenn2'!

!Sudoku commentStamp: 'DWT 1/15/2013 17:20:32.735' prior: 0!
Sudoku is a program to let you solve and make sudoku puzzles.

Instance Variables
	sudokuGame:		<Object>

sudokuGame
	- xxxxx
!

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 1/18/2013 17:46:44.947'!
fileNew: filename
	| stream gameValues emptyTest lockedState |
	
	gameValues:= 'This is the sudoku game ', filename, ' saved on: ',  Date today, '.', CR.
	
	1 to: 9 do: [:row| 
		
		1 to: 9 do: [:column| 
			emptyTest := (sudokuGame getGridCellValue: row column: column).
			lockedState:= (sudokuGame lockGridCell: row column: column).
			(emptyTest = '') 
				ifTrue:[gameValues:= gameValues, '0'] 
				ifFalse:[gameValues:= gameValues, emptyTest].
			(lockedState = true) 
				ifTrue:[gameValues:= gameValues, 't ']
				ifFalse:[gameValues:= gameValues, 'f ']			
			].
		gameValues := gameValues, CR
		].
	
			
	stream := FileStream forceNewFileNamed: (filename asString, '.sdk') asString. 

	stream 
	
	nextPutAll: gameValues asString;
	close.! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 1/24/2013 12:07:57.433'!
fileOpen: filename
	| stream  lineNumber cellValue lockState gameValues |
	"Doesn't work yet !!"
	
	gameValues:= Array new: 10.
	lineNumber:= 1.
	
	stream := FileStream readOnlyFileNamed: (filename asString, '.sdk'). 
	[stream atEnd] whileFalse: [
 		 | row |
		row := stream upTo: Character cr.
		gameValues at: lineNumber put: row.
		lineNumber:= lineNumber + 1.
	].
	stream close.

	2 to: 10 do: [ :rowNum |
		 1 to: 9 do: [ :columnNum |
					cellValue := (((gameValues at: rowNum) at: ((columnNum * 3)-2))) digitValue.
					lockState := ((gameValues at: rowNum) at: ((columnNum * 3)-1)) asString.
					
					"*** Strange behaviour: this next line doesn't put the values into the Sudoku game,
					but the line at the bottom which uses the same call, is able to put the right thing in ***"
					
					sudokuGame setGridCellValue: cellValue row: (rowNum-1) column: columnNum.
					"Transcript show: lockState asString, ' (' , (rowNum-1), ', ',  columnNum, ') '."
					(lockState = 't')
						ifTrue: [sudokuGame lockGridCell: true row: (rowNum-1) column: columnNum.]
						ifFalse: [sudokuGame lockGridCell: false row: (rowNum-1) column: columnNum]
		  ].
		"Transcript show: CR."
	].
! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 1/22/2013 16:54:09.457'!
fileOpenTesting: filename
"BROKEN ... can't seem to do a loop within stream, since it doesn't recognize stream inside the loop. Probably a scope problem. One solution is to stream into an array, and then close the stream and finally work on the array using a loop."
	| stream  gameValues copiedFileName cellValue lockState |
	"Doesn't work yet !!"
	
	"stream := FileStream readOnlyFileNamed: (filename asString) 

		do: [:rowNumber | 1 to: 10.    ""Each line is a row in Sudoku""
			(rowNumber > 1)			  ""skip title line""
				ifTrue: [gameValues := stream getLine
					do: [:columnNumber | 1 to: 9.
						cellValue := (gameValues at: ((columnNumber * 3)-2)).
						lockState := (gameValues at: ((columnNumber * 3)-1)).
						
						self setGridCellValue: cellValue row: (rowNumber-1) column: columnNumber.
						self lockGridCell: lockState row: rowNumber	 column: columnNumber.
					].
		
		stream nextLine. ].
	
	""test and see if we read the file correctly""	
	copiedFileName := filename , '_copied'.	
	stream := FileStream forceNewFileNamed: (copiedFileName asString).
	stream 
	nextPutAll: gameValues asString;
	close."
		
		
	"*** strange behaviour .. if all the Transcripts are combined into one line,
					the Transcript shows: UndefinedObject>>DoIt (dtSudoku is Undeclared) ***"
					
					"Transcript show: cellValue.
					Transcript show: '('.
					Transcript show: rowNum-1.
					Transcript show: ','.
					Transcript show: columnNum.
					Transcript show: '); '."
					"Transcript show: ' (', ', ', ' )', ' ;'."! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 1/24/2013 12:03:17.798'!
fileSave: filename
	| stream gameValues emptyTest lockedState |
	
	gameValues:= 'This is the sudoku game ', filename, ' saved on: ',  Date today, '.', CR.
	
	1 to: 9 do: [:row| 
		
		1 to: 9 do: [:column| 
			emptyTest := (sudokuGame getGridCellValue: row column: column).
			lockedState:= (sudokuGame lockGridCell: row column: column).
			(emptyTest = '') 
				ifTrue:[gameValues:= gameValues, '0'] 
				ifFalse:[gameValues:= gameValues, emptyTest].
			(lockedState = true) 
				ifTrue:[gameValues:= gameValues, 't ']
				ifFalse:[gameValues:= gameValues, 'f ']			
			].
		gameValues := gameValues, CR
		].
	
			
	stream := FileStream fileNamed: (filename asString, '.sdk') asString. 

	stream 
	
	nextPutAll: gameValues asString;
	close.! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 4/11/2013 16:42:07.801'!
initialize
	super initialize.
	self borderWidth: 0.
	self color: Color lightYellow.
	self extent: 9*(52.5@52.5).
	
	sudokuGame:= SudokuGrid new.
	self addMorph: sudokuGame.
	
	sudokuMenu := StandardFileMenu new.

"To add menuTitles simply add more with: statements"
	menuTitles := #('New' 'Open' 'Save' 'Create' 'Hint' 'Help' 'Quit').
	menuItems := menuTitles size.
	
	menuBlocks := Array new: menuItems.
	1 to:  menuItems do: [:itemNum |
		menuBlocks at: itemNum put: SudokuMenu new.
		self addMorph: (menuBlocks at: itemNum).
		(menuBlocks at: itemNum) position: 470@(20*(itemNum-1)).
		(menuBlocks at: itemNum) menuNum: (itemNum-1).
	]. 

	1 to: menuItems do: [:tileNum |
		(menuBlocks at: tileNum) tileTitle: (menuTitles at: tileNum)
	].
	! !

!Sudoku methodsFor: 'as yet unclassified' stamp: 'DWT 3/7/2013 11:46:29.108'!
quitSudoku
	self delete.! !

BorderedMorph subclass: #SudokuBlock
	instanceVariableNames: 'values cellNumber cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 3/21/2013 11:36:43.462'!
addressToCellNumber: aRow and: aColumn

	( (aRow isInteger
		and: [aRow >= 1]
		and: [aRow < 4]) and:
		
		(aColumn isInteger
		and: [aColumn >= 1]
		and: [aColumn < 4]) )

	ifTrue: [cellNumber:= 3*(aRow-1) + aColumn ]
! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 2/2/2012 12:29'!
availableValues
	^values   "This is an array of available numbers to put in the block"! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 3/21/2013 12:06:43.185'!
getCellValue: aRow and: aColumn
	| aCellValue |
	self gridAddressToCellNumber: aRow and: aColumn.
			aCellValue:= (cells at: aRow at: aColumn).
			Transcript show: aCellValue.
			^aCellValue cellValue.! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 3/28/2013 16:34:07.381'!
initialize
	super initialize.
	self	borderColor: Color red.
	self	borderWidth: 5.
	self 	extent: 3*(53@53).  "better to use extent property NOT 55@55"
	self	color: Color lightYellow.
		
	cells := Matrix new: 3.
	1 to: 3 do: [:rowNum |
		1 to: 3 do: [:colNum | | index |
			index := (rowNum-1)*3+colNum.
			cells at: rowNum at: colNum put: SudokuCell new.
			(cells at: rowNum at: colNum) position: (52*(rowNum-1))@(52*(colNum-1)).
			self addMorph: (cells at: rowNum at: colNum).
		].
	].

	"values:= {1, 2, 3, 4, 5, 6, 7, 8, 9}. "      "these are all valid values in the block at init."
	"as they get used up just delete them, if they become unused, put them back in"! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 3/28/2013 16:31:02.858'!
lockCell: aRow column: aColumn

	self gridAddressToCellNumber: aRow and: aColumn.
		(cells at: aRow at: aColumn) cellLock! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 3/28/2013 16:33:14.144'!
lockCell: aBoolean row: aRow column: aColumn

	self addressToCellNumber: aRow and: aColumn.
	(aBoolean isKindOf: Boolean)		
		ifTrue: [
			(cells at: aRow at: aColumn) cellLock: aBoolean.]! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 2/23/2012 09:21'!
reclaimAvailableValue: aNumber
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10])
		ifTrue: [ self changed].

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 2/23/2012 09:20'!
removeAvailableValue: aNumber
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10])
		ifTrue: [ self changed].

	! !

!SudokuBlock methodsFor: 'as yet unclassified' stamp: 'DWT 3/21/2013 12:08:26.544'!
setCellValue: aValue row: aRow column: aColumn
	self addressToCellNumber: aRow and: aColumn.
	(aValue isInteger
		and: [aValue >= 0]
		and: [aValue < 10])
		
		ifTrue: [
			(cells at: aRow at: aColumn) cellValue: aValue.
			].
			
	

	! !

BorderedMorph subclass: #SudokuCell
	instanceVariableNames: 'cellValue cellRow cellColumn cellBlockNumber cellContents cellText cellLocked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellBlockNumber
	^cellBlockNumber.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:09'!
cellBlockNumber: aNumber
	"Set the block number value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellBlockNumber:= aNumber.
			self changed].
! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellColumn
	^cellColumn.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:10'!
cellColumn: aNumber
	"Set the column value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellColumn:= aNumber.
			self changed].
! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellLock
	^cellLocked.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/24/2013 11:20:05.305'!
cellLock: aBoolean
	"Set the lock to disable changing cellContents when cellValue is not 0" 
	
	"Squeak doesn't appear to know about isBoolean"
	((aBoolean isKindOf: Boolean) "and: (cellValue > 0)")      
		ifTrue: [cellLocked:= aBoolean.
			self changed.].

		
	"Note, SBE-183 says that isBoolean, isInteger kind of methods violate the principle of encapsulation, and that you should query the object instead ... no examples are given, and SBE is inconsistent in giving its code examples, since it uses this very feature."! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:12'!
cellRow
	^cellRow.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:11'!
cellRow: aNumber
	"Set the row value for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellRow:= aNumber.
			self changed].
! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 1/26/2012 13:12'!
cellValue
	^cellContents.! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 4/19/2012 18:12'!
cellValue: aNumber
	"Set the shown number for the Sudoku cell."
	(aNumber isInteger
		and: [aNumber >= 1]
		and: [aNumber < 10]
		and: [cellLocked = false])
		ifTrue: [cellValue:= aNumber.
			cellContents:= cellValue asString.
			self changed].
		(aNumber = 0and: [cellLocked = false]) 
		ifTrue: [cellContents:= ''.
			self changed].! !

!SudokuCell methodsFor: 'drawing' stamp: 'DWT 4/26/2012 09:18'!
drawOn:  aCanvas 
	super drawOn: aCanvas. 
		(self cellLock) ifTrue: [cellText color: Color red].
		(self cellLock) ifFalse: [cellText color: Color black].
		cellText contents: cellContents.

! !

!SudokuCell methodsFor: 'accessing' stamp: 'DWT 4/19/2012 16:18'!
eraseCellValue
	"Set the shown number for the Sudoku cell."
	
	(cellLocked:= false)
		ifTrue: [cellContents:= ' ']
! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/26/2012 08:19'!
handleKeystroke: anEvent 
	| keyStroke |
	keyStroke:= anEvent keyValue.
	"ASCII 48 is the number 0, and ASCII 57 is the number 9"
	(keyStroke > 47 and: [keyStroke < 58])
		ifTrue: [self cellValue: (keyStroke-48)]. 
	"ASCII 108 is the letter l, for lock"
	(keyStroke = 108) ifTrue: [self cellLock: true].
	"ASCII 117 is the letter u, for unlock"
	(keyStroke = 117) ifTrue: [self cellLock: false].
	! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/19/2012 15:29'!
handlesMouseOver: anEvent
	^true! !

!SudokuCell methodsFor: 'initialization' stamp: 'DWT 4/26/2012 09:19'!
initialize
	super initialize.
	self extent: 55@55.
	self borderWidth: 1.
	self borderColor: (Color blue alpha: 0.4).
	self color: Color lightYellow.
	cellContents := ''.
	cellLocked:= false.       "Use lock for generated suduko numbers in cell, use (bold)."
	cellRow:= 0.					  "Row, column and block number are defined when a new block is created"
	cellColumn:= 0.                 
	cellBlockNumber:=0.
	cellText:= StringMorph new contents: cellContents.
	self addMorph: (cellText
		center: self position + 0.5*(self extent))
		
	
"*** This was my first working bit, but I don't know how to communicate to it, so I thought it would be best to
try to instantiate an object, which then should be accesible:

self addMorph: ((StringMorph contents: cellContents)
		center: self position + 0.5*(self extent))"
		
"**************************************************************************"
		
"*** How to use TextMorph ... the problem here is that it also takes over the keyboard, and it doesn't seem to 
have any value to inspect: 

	cellText:= TextMorph new contents: cellContents.
	self addMorph: (cellText
		center: self position + 0.5*(self extent))"
	
	
	
	
	
	 ! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/19/2012 15:55'!
mouseEnter: anEvent 
	anEvent hand newKeyboardFocus: self.
	self color: Color yellow.
	! !

!SudokuCell methodsFor: 'user interface' stamp: 'DWT 4/19/2012 15:55'!
mouseLeave: anEvent 
	anEvent hand newKeyboardFocus: nil.
	self color: Color lightYellow.! !

BorderedMorph subclass: #SudokuGrid
	instanceVariableNames: 'cellRow cellColumn cellNumber blocks rowGroup columnGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 3/14/2013 11:45:20.21'!
getGridCellValue:  aGridRow column: aGridColumn
	| aGridValue |
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
			aGridValue:= (blocks at: rowGroup at: columnGroup) getCellValue: cellRow and: cellColumn.
			Transcript show: aGridValue.
			^aGridValue.
		! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 3/21/2013 11:33:52.571'!
gridAddressToCellNumber: aGridRow and: aGridColumn
	"| rowGroup columnGroup |  keep these values"
	( (aGridRow isInteger
		and: [aGridRow >= 1]
		and: [aGridRow < 10]) and:
		
		(aGridColumn isInteger
		and: [aGridColumn >= 1]
		and: [aGridColumn < 10]) )
		
	"ifTrue: [gridCellNumber:=  'cell', ((3*(aGridRow-1) + aGridColumn)) asString ] "
	"Insert BRUTE FORCE ..."
	
	ifTrue: [ 
		((aGridRow >=1) and: [aGridRow < 4]) ifTrue: [rowGroup:= 1].
		((aGridRow >=4) and: [aGridRow < 7]) ifTrue: [rowGroup:= 2].
		((aGridRow >=7) and: [aGridRow < 10]) ifTrue: [rowGroup:= 3].
		
		((aGridColumn >=1) and: [aGridColumn < 4]) ifTrue: [columnGroup:= 1].
		((aGridColumn >=4) and: [aGridColumn < 7]) ifTrue: [columnGroup:= 2].
		((aGridColumn >=7) and: [aGridColumn < 10]) ifTrue: [columnGroup:= 3].
		
		cellRow:= aGridRow - (3*(rowGroup-1)).		
		cellColumn:= aGridColumn - (3*(columnGroup-1)).		
		cellNumber:= 3*(cellRow-1) + cellColumn.
		].
! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 3/14/2013 10:57:43.34'!
initialize
	super initialize.
	self 	extent: 9*(52.5@52.5).
	self	borderWidth: 1.
	self	color: Color lightYellow.
		
	blocks := Matrix new: 3.
	1 to: 3 do: [:rowNum |
		1 to: 3 do: [:colNum | | index |
			index := (rowNum-1)*3+colNum.
			blocks at: rowNum at: colNum put: SudokuBlock new.
			(blocks at: rowNum at: colNum) position: (156*(rowNum-1))@(156*(colNum-1)).
			self addMorph: (blocks at: rowNum at: colNum).
		].
	].
	! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 3/21/2013 11:26:14.012'!
lockGridCell: aGridRow column: aGridColumn
	| aGridLock |
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
			aGridLock:= (blocks at: rowGroup at: columnGroup) lockCell: cellRow column: cellColumn.
			Transcript show: aGridLock.
			^aGridLock.! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 3/21/2013 11:29:39.106'!
lockGridCell: aBoolean row: aGridRow column: aGridColumn
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
	(aBoolean isKindOf: Boolean)
			ifTrue: [
				(blocks at: rowGroup at: columnGroup) lockCell: aBoolean row: cellRow column: cellColumn.
			].! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 4/11/2013 16:31:21.68'!
quitSudoku
	self delete.! !

!SudokuGrid methodsFor: 'as yet unclassified' stamp: 'DWT 3/21/2013 11:19:42.628'!
setGridCellValue: aGridCellValue row: aGridRow column: aGridColumn
	
	self gridAddressToCellNumber: aGridRow and: aGridColumn.
	(aGridCellValue isInteger
		and: [aGridCellValue >= 1]
		and: [aGridCellValue < 10])
		
			ifTrue: [
				(blocks at: rowGroup at: columnGroup) setCellValue: aGridCellValue row: cellRow column: cellColumn.].! !

BorderedMorph subclass: #SudokuMenu
	instanceVariableNames: 'subMenuTitles subMenuItems subMenuBlocks menuNum aboutDialog help menuContents menuText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sudoku-Tenn2'!

!SudokuMenu methodsFor: 'drawing' stamp: 'DWT 3/28/2013 16:52:13.473'!
drawOn:  aCanvas 
	super drawOn: aCanvas. 
		"(self cellLock) ifTrue: [cellText color: Color red].
		(self cellLock) ifFalse: [cellText color: Color black]."
		menuText contents: menuContents.

! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 1/31/2013 19:53:53.979'!
handleKeystroke: anEvent 
	| keyStroke |
	keyStroke:= anEvent keyValue.
	"ASCII 48 is the number 0, and ASCII 57 is the number 9"
	(keyStroke > 47 and: [keyStroke < 58])
		ifTrue: [self cellValue: (keyStroke-48)]. 
	"ASCII 108 is the letter l, for lock"
	(keyStroke = 108) ifTrue: [self cellLock: true].
	"ASCII 117 is the letter u, for unlock"
	(keyStroke = 117) ifTrue: [self cellLock: false].
	! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 2/4/2013 18:48:29.12'!
handlesMouseDown: anEvent
	"^self type == #mouseDown"
	"Transcript show: 'Mouse is down'."
	^true.! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 1/31/2013 19:53:53.986'!
handlesMouseOver: anEvent
	^true! !

!SudokuMenu methodsFor: 'initialization' stamp: 'DWT 3/28/2013 16:52:40.734'!
initialize
	super initialize.
	self extent: 80@20.
	self borderWidth: 1.
	self borderColor: (Color red).
	self color: Color lightBlue.
	menuContents := ''.
	menuText:= StringMorph new contents: menuContents.
	self addMorph: (menuText).
	menuText position: 4@0.
		
	
"*** This was my first working bit, but I don't know how to communicate to it, so I thought it would be best to
try to instantiate an object, which then should be accesible:

self addMorph: ((StringMorph contents: cellContents)
		center: self position + 0.5*(self extent))"
		
"**************************************************************************"
		
"*** How to use TextMorph ... the problem here is that it also takes over the keyboard, and it doesn't seem to 
have any value to inspect: 

	cellText:= TextMorph new contents: cellContents.
	self addMorph: (cellText
		center: self position + 0.5*(self extent))"
	
	
	
	
	
	 ! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 2/4/2013 19:33:22.119'!
menuNum
	"Set the the menu item number."
	^menuNum.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 2/4/2013 19:32:37.69'!
menuNum: aNumber
	"Set the the menu item number."
	menuNum := aNumber.! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 4/11/2013 16:39:29.312'!
mouseDown: anEvent 
	"To add menuTitles simply add more with: statements"
	(menuNum = 0) ifTrue:[Transcript show: '"New" not implimented yet.'; cr].
	(menuNum = 1) ifTrue:[Transcript show: '"Open" not implimented yet.'; cr].
	(menuNum = 2) ifTrue:[Transcript show: '"Save" not implimented yet.'; cr.
		super fileSave: 'testing'.].
	(menuNum = 3) ifTrue:[Transcript show: '"Create" not implimented yet.'; cr].
	(menuNum = 4) ifTrue:[Transcript show: '"Hint" not implimented yet.'; cr].
	(menuNum = 5) ifTrue:[Transcript show: '"Help" not implimented yet.'; cr.
		HelpBrowser openOn: SudokuHelp.
		].
	(menuNum = 6) ifTrue: [super sudokuGame quitSudoku].   
	" .... this doe NOT work!!"

	
! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 1/31/2013 20:03:59.984'!
mouseEnter: anEvent 
	anEvent hand newKeyboardFocus: self.
	self color: Color blue.
	! !

!SudokuMenu methodsFor: 'user interface' stamp: 'DWT 1/31/2013 20:05:25.563'!
mouseLeave: anEvent 
	anEvent hand newKeyboardFocus: nil.
	self color: Color lightBlue.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 2/4/2013 18:31:04.336'!
tileEvent: event
	"This is the mouse down action"
	^(event) asSymbol.! !

!SudokuMenu methodsFor: 'accessing' stamp: 'DWT 3/28/2013 16:53:21.049'!
tileTitle: aString
	"Set the menu title"
	(aString isString)
		ifTrue: [ menuContents:= aString.
			self changed].! !
